#import "PDTVDoc.h"
#import "PDTVController.h"
#import <png.h>

@implementation PDTVDoc

- (BOOL)loadPDT: (NSString *)str;
{
	int num, srccount, i, j, k, bit, count, maskptr, n;
	int filesize, xsize, ysize, size;
	unsigned char *repeat, *buf, *bufend, *src;
	unsigned char *srcbuf;
	unsigned char flag;
	int index[16];
	unsigned char tmp[32];

	unsigned char *mask = NULL;
	unsigned char *buffer = NULL;
	srcbuf = 0;

	FILE *fp = fopen([str UTF8String], "rb");
	if ( fp ) {
		fseek(fp, 0, 0);
		fread(tmp, 32, 1, fp);
		if (!memcmp(tmp, "PDT1", 4)) {
			filesize = (*(tmp+11) << 24) | (*(tmp+10) << 16) | (*(tmp+9) << 8) | *(tmp+8);
			xsize    = (*(tmp+15) << 24) | (*(tmp+14) << 16) | (*(tmp+13) << 8) | *(tmp+12);
			ysize    = (*(tmp+19) << 24) | (*(tmp+18) << 16) | (*(tmp+17) << 8) | *(tmp+16);
			maskptr  = (*(tmp+31) << 24) | (*(tmp+30) << 16) | (*(tmp+29) << 8) | *(tmp+28);
			size     = xsize * ysize;
			if ( filesize>32 ) {
				srcbuf = (unsigned char*)malloc(filesize);
				if ( srcbuf ) {
					fread(srcbuf+32, filesize-32, 1, fp);
					memcpy(srcbuf, tmp, 32);
				}
			}
			else {
				fclose(fp);
				return NO;
			}
		}
		else {
			fclose(fp);
			return NO;
		}
		fclose(fp);
	}
	else return NO;

	if ( srcbuf ) {
		if ( maskptr ) {								// Maskꍇ
			mask = (unsigned char*)malloc(size);
			memset(mask, 0, size);
			src = srcbuf+maskptr;
			bit = 0;
			srccount = filesize-maskptr;
			bufend = mask+size;
			buf = mask;
			while ( (buf<bufend)&&(srccount>0) ) {
				if (!bit) {
					bit = 8;
					flag = *src++;
					srccount--;
				}
				if ( flag&0x80 ) {
					*buf++ = *src++;
					srccount--;
				} else {
					count = (*src++)+2;
					repeat = buf-((*src++)+1);
					srccount -= 2;
					for (i=0; (i<count)&&(buf<bufend); i++) *buf++ = *repeat++;
				}
				bit--;
				flag <<= 1;
			}
		}

		size *= 3;	// RGBe1oCg
		buffer = (unsigned char*)malloc(size);
		if ( !strcmp((char*)srcbuf, "PDT10") ) {
		// PDT10`
			src = srcbuf+32;
			bit = 0;
			if ( maskptr )
				srccount = maskptr-32;
			else
				srccount = filesize-32;
			bufend = buffer+size;
			buf = buffer;
			while ( (buf<bufend)&&(srccount>0) ) {
				if (!bit) {
					bit = 8;
					flag = *src++;
					srccount--;
				}
				if ( flag&0x80 ) {
					*buf++ = *src++;
					*buf++ = *src++;
					*buf++ = *src++;
					srccount -= 3;
				} else {
					num  = *src++;
					num += ((*src++)<<8);			// ̓gGfBAWORD
					srccount -= 2;
					count = ((num&15)+1)*3;			// 4bitRs[. 2񂪍ŏPʁH
					repeat = buf-((num>>4)+1)*3;	// buf͎݈̏ʒuwĂ̂ŁA1oCg߂ɖ߂
					for (i=0; (i<count)&&(buf<bufend); i++) *buf++ = *repeat++;
				}
				bit--;
				flag <<= 1;
			}

		} else {
		// PDT11
			for (i=0; i<16; i++) {					// s[gIndexTable
				index[i]  = (srcbuf[i*4+0x420]);
				index[i] |= (srcbuf[i*4+0x421]<<8);
				index[i] |= (srcbuf[i*4+0x422]<<16);
				index[i] |= (srcbuf[i*4+0x423]<<24);
			}
			src = srcbuf+0x460;
			bit = 0;
			if ( maskptr )
				srccount = maskptr-32;
			else
				srccount = filesize-32;
			bufend = buffer+size;
			buf = buffer;
			while ( (buf<bufend)&&(srccount>0) ) {
				if (!bit) {
					bit = 8;
					flag = *src++;
					srccount--;
				}
				if ( flag&0x80 ) {
					n = (*src++)*4+0x20;
					*buf++ = srcbuf[n];
					*buf++ = srcbuf[n+1];
					*buf++ = srcbuf[n+2];
					srccount--;
				} else {
					num  = *src++;					// BYTE
					srccount--;
					count = (((num>>4)&15)+2)*3;	// 4bitRs[. 2񂪍ŏPʁH
					if ( (buf+count)>=bufend ) count = bufend-buf;
					repeat = buf-(index[num&15])*3;	// IndexŖ߂ʒu߂H
					for (i=0; (i<count)&&(buf<bufend); i++) *buf++ = *repeat++;
				}
				bit--;
				flag <<= 1;
			}
		}
		if(maskptr) {
			hasAlpha = YES;
			bitmapSize = xsize*ysize*4;
			bitmap = (unsigned char *)malloc(bitmapSize);
			j=0;k=0;
			for(i=0;i<bitmapSize;i+=4,j+=3,k++) {
				bitmap[i] = buffer[j+2];
				bitmap[i+1] = buffer[j+1];
				bitmap[i+2] = buffer[j];
				bitmap[i+3] = mask[k];
			}
			free(mask);
		}
		else {
			hasAlpha = NO;
			bitmapSize = size;
			bitmap = (unsigned char *)malloc(bitmapSize);
			for(i=0;i<bitmapSize;i+=3) {
				bitmap[i] = buffer[i+2];
				bitmap[i+1] = buffer[i+1];
				bitmap[i+2] = buffer[i];
			}
		}
		
		x = xsize;
		y = ysize;
		
		free(srcbuf);
		free(buffer);
		return YES;
	}
	
	return NO;
}

- (void)fillRGBAImage:(NSBitmapImageRep *)rep
{
	unsigned char *plane = [rep bitmapData];
	memcpy(plane,bitmap,bitmapSize);
}

- (void)fillRGBImage:(NSBitmapImageRep *)rep
{
	int i,j;
	unsigned char *plane = [rep bitmapData];
	for(i=0,j=0;i<x*y*3;i+=3,j+=4) {
		plane[i] = bitmap[j];
		plane[i+1] = bitmap[j+1];
		plane[i+2] = bitmap[j+2];
	}
}

- (void)fillAlphaImage:(NSBitmapImageRep *)rep
{
	int i,j;
	unsigned char *plane = [rep bitmapData];
	for(i=0,j=0;i<x*y;i++,j+=4) {
		plane[i] = bitmap[j+3];
	}
}

- (id)initWithFile: (NSString *)str owner:(id)owner count:(int)n success:(BOOL *)flag
{
	[super init];
	bitmap = nil;
	*flag = [self loadPDT:str];
	if(!(*flag)) return self;
	
	[NSBundle loadNibNamed:@"PDTVDoc" owner:self];
	delegate = [owner retain];
	filename = [[str lastPathComponent] retain];
	mode = 0;
	
	NSSize size;
	size.width = x;
	size.height = y;
	[o_mainWindow setContentSize:size];
	[o_mainWindow center];
	NSRect frame = [o_mainWindow frame];
	frame.origin.x += 20*n;
	frame.origin.y -= 20*n;
	[o_mainWindow setFrame:frame display:NO];
	[o_mainWindow setTitle: [str lastPathComponent]];
	
	NSImage *img = [[NSImage alloc] init];
	unsigned char* planes[1];
	planes[0] = (hasAlpha ? NULL : bitmap);
	int spp = (hasAlpha ? 4 : 3);
    NSBitmapImageRep *imgRep = [[NSBitmapImageRep alloc]
                initWithBitmapDataPlanes: planes
                pixelsWide: x
                pixelsHigh: y
                bitsPerSample: 8
                samplesPerPixel: spp
                hasAlpha: hasAlpha
                isPlanar: NO
                colorSpaceName: @"NSCalibratedRGBColorSpace"
                bytesPerRow: x*spp
                bitsPerPixel: 8*spp];
	if(hasAlpha) [self fillRGBAImage:imgRep];
	[img addRepresentation: imgRep];
	[o_imgView setImage: img];
	[imgRep release];
	[img release];
	[o_mainWindow makeFirstResponder:o_imgView];
	[o_mainWindow makeKeyAndOrderFront: self];
	return self;
}

- (void)showAlert
{
	NSBeginCriticalAlertSheet(@"Save failed", @"OK", nil, nil, [NSApp mainWindow], nil, nil, nil, nil, @"Can't save file.");
}

- (void)exportPNG: (NSString *)path saveMode:(int)m
{
	png_structp     png_ptr;
	png_infop       info_ptr;
	unsigned char **image;
	int i,j,k=0,bpp;
	
	FILE *fp = fopen([path UTF8String], "wb");
	if(!fp) {
		[self performSelector:@selector(showAlert) withObject:nil afterDelay:0.5];
		return;
	}
	image = (png_bytepp)malloc(y * sizeof(png_bytep));
	if(hasAlpha && m == 0) { /* RGBA */
		for(j=0; j<y; j++)
			image[j] = (png_bytep)malloc(x * sizeof(png_byte) * 4);
		for(j=0; j<y; j++) {
			for(i=0;i<x*4; i++) {
				image[j][i] = bitmap[k++];
			}
		}
	}
	else if(hasAlpha && m == 1) { /* RGB of RGBA */
		for(j=0; j<y; j++)
			image[j] = (png_bytep)malloc(x * sizeof(png_byte) * 3);
		for(j=0; j<y; j++) {
			for(i=0;i<x*3; i+=3,k+=4) {
				image[j][i] = bitmap[k];
				image[j][i+1] = bitmap[k+1];
				image[j][i+2] = bitmap[k+2];
			}
		}
	}
	else if(hasAlpha && m == 2) { /* Alpha of RGBA */
		for(j=0; j<y; j++)
			image[j] = (png_bytep)malloc(x * sizeof(png_byte));
		for(j=0; j<y; j++) {
			for(i=0;i<x; i++,k+=4) {
				image[j][i] = bitmap[k+3];
			}
		}
	}
	else if(m == 3) { /* current image */
		NSBitmapImageRep *rep = [NSBitmapImageRep imageRepWithData: [[o_imgView image] TIFFRepresentation]];
		unsigned char *data = [rep bitmapData];
		bpp = [rep bitsPerPixel] / 8;
		for(j=0; j<y; j++)
			image[j] = (png_bytep)malloc(x * sizeof(png_byte) * bpp);
		for(j=0; j<y; j++) {
			for(i=0;i<x*bpp; i++) {
				image[j][i] = data[k++];
			}
		}
	}
	else { /* RGB */
		for (j=0; j<y; j++)
			image[j] = (png_bytep)malloc(x * sizeof(png_byte) * 3);
		for(j=0; j<y; j++) {
			for(i=0;i<x*3; i++) {
				image[j][i] = bitmap[k++];
			}
		}
	}
	
	png_ptr = png_create_write_struct(
		PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	info_ptr = png_create_info_struct(png_ptr);
	png_init_io(png_ptr, fp);
	if((hasAlpha && m == 0) || (m == 3 && bpp == 4)) {
		png_set_IHDR(png_ptr, info_ptr, x, y,
			8, PNG_COLOR_TYPE_RGBA, PNG_INTERLACE_NONE,
			PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
	}
	else if(!hasAlpha || (hasAlpha && m == 1) || (m == 3 && bpp == 3)) {
		png_set_IHDR(png_ptr, info_ptr, x, y,
			8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE,
			PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
	}
	else {
		//png_set_invert_mono(png_ptr);
		png_set_IHDR(png_ptr, info_ptr, x, y,
			8, PNG_COLOR_TYPE_GRAY, PNG_INTERLACE_NONE,
			PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
	}
	png_write_info(png_ptr, info_ptr);
	png_write_image(png_ptr, image);
	png_write_end(png_ptr, info_ptr);
	png_destroy_write_struct(&png_ptr, &info_ptr);
	fclose(fp);
	for(j=0; j<y; j++) free(image[j]);
	free(image);
}

- (NSString *)filename
{
	return filename;
}

- (void)changeToRGBA
{
	if(!hasAlpha) return;
	if(mode == 0) return;
	mode = 0;
	NSImage *img = [o_imgView image];
	[img recache];
	//[img lockFocus];
	[img removeRepresentation:[[img representations] objectAtIndex:0]];
	NSBitmapImageRep *imgRep = [[NSBitmapImageRep alloc]
			initWithBitmapDataPlanes: NULL
			pixelsWide: x
			pixelsHigh: y
			bitsPerSample: 8
			samplesPerPixel: 4
			hasAlpha: YES
			isPlanar: NO
			colorSpaceName: @"NSCalibratedRGBColorSpace"
			bytesPerRow: x*4
			bitsPerPixel: 32];
	[self fillRGBAImage: imgRep];
	[img addRepresentation: imgRep];
	[imgRep release];
	[o_mainWindow display];
	//[img unlockFocus];
}

- (void)changeToRGB
{
	if(!hasAlpha) return;
	if(mode == 1) return;
	mode = 1;
	NSImage *img = [o_imgView image];
	[img recache];
	//[img lockFocus];
	[img removeRepresentation:[[img representations] objectAtIndex:0]];
	NSBitmapImageRep *imgRep = [[NSBitmapImageRep alloc]
			initWithBitmapDataPlanes: NULL
			pixelsWide: x
			pixelsHigh: y
			bitsPerSample: 8
			samplesPerPixel: 3
			hasAlpha: NO
			isPlanar: NO
			colorSpaceName: @"NSCalibratedRGBColorSpace"
			bytesPerRow: x*3
			bitsPerPixel: 24];
	[self fillRGBImage: imgRep];
	[img addRepresentation: imgRep];
	[imgRep release];
	[o_mainWindow display];
	//[img unlockFocus];
}

- (void)changeToAlpha
{
	if(!hasAlpha) return;
	if(mode == 2) return;
	mode = 2;
	NSImage *img = [o_imgView image];
	[img recache];
	//[img lockFocus];
	[img removeRepresentation:[[img representations] objectAtIndex:0]];
	NSBitmapImageRep *imgRep = [[NSBitmapImageRep alloc]
			initWithBitmapDataPlanes: NULL
			pixelsWide: x
			pixelsHigh: y
			bitsPerSample: 8
			samplesPerPixel: 1
			hasAlpha: NO
			isPlanar: NO
			colorSpaceName: @"NSCalibratedWhiteColorSpace"
			bytesPerRow: x
			bitsPerPixel: 8];
	[self fillAlphaImage: imgRep];
	[img addRepresentation: imgRep];
	[imgRep release];
	[o_mainWindow display];
	//[img unlockFocus];
}

- (BOOL)hasAlpha
{
	return hasAlpha;
}

- (void)resetView
{
	NSImage *img = [o_imgView image];
	//[img recache];
	[img removeRepresentation:[[img representations] objectAtIndex:0]];
	unsigned char* planes[1];
	planes[0] = (hasAlpha ? NULL : bitmap);
	int spp = (hasAlpha ? 4 : 3);
	NSBitmapImageRep *imgRep = [[NSBitmapImageRep alloc]
			initWithBitmapDataPlanes: planes
			pixelsWide: x
			pixelsHigh: y
			bitsPerSample: 8
			samplesPerPixel: spp
			hasAlpha: hasAlpha
			isPlanar: NO
			colorSpaceName: @"NSCalibratedRGBColorSpace"
			bytesPerRow: x*spp
			bitsPerPixel: 8*spp];
	if(hasAlpha) [self fillRGBAImage:imgRep];
	[img addRepresentation: imgRep];
	[imgRep release];
	mode = 0;
	[delegate setEnableChangeView:hasAlpha select:0];
}

- (void)paste
{
	NSPasteboard *pb = [NSPasteboard generalPasteboard];
	NSImage *img = [[NSImage alloc] initWithPasteboard: pb];
	if(img) {
		NSSize size;
		size.width = x;
		size.height = y;
		[img setScalesWhenResized: [delegate doesScale]];
		[img setSize: size];
		[self resetView];
		NSImage *oldImg = [o_imgView image];
		[oldImg lockFocus];
		if(hasAlpha) {
			[img compositeToPoint:NSZeroPoint operation:NSCompositeDestinationOver];
		}
		else [img compositeToPoint:NSZeroPoint operation:NSCompositeSourceOver];
		[oldImg unlockFocus];
		[img release];
		[o_mainWindow display];
	}
}

- (void)dealloc
{
	if(delegate) [delegate release];
	if(filename) [filename release];
	if(bitmap) free(bitmap);
	[super dealloc];
}

- (void)windowWillClose:(NSNotification *)aNotification
{
	[delegate windowDidClose:self];
}

- (void)windowDidBecomeMain:(NSNotification *)aNotification
{
	[delegate setEnableChangeView:hasAlpha select:mode];
}

@end
